<?php
if(isset($_POST['email'])) {
     
    ////// Tyt tiedot alla oleville riveille //////
    $email_to = "linda@viherlinda.fi";
    $email_subject = "Viesti YSI-kotisivultasi!";
    $page_url = "https://www.viherlinda.fi/";
    /////////////////////////////////////////////////
     
     
    function died($error) {
        echo "Olemme pahoillamme, mutta palautteen lhettmisess tapahtui virhe. ";
        echo "Tapahtui alla olevat virheet.<br /><br />";
        echo $error."<br /><br />";
        echo "Ole hyv ja korjaa virheet.<br /><br />";
        die();
    }

    // Tarkistetaan botti-ansa
    if(isset($_POST['title']) && !empty($_POST['title'])) {
        died('Tarkista lomake uudelleen.');
    }

    //reCAPTCHA validation
    $secret = "6LfOEiwUAAAAAKxjIfWgxgs2wV2uPtrJEPbUjH-Q"; //secret key
    $remoteip = $_SERVER["REMOTE_ADDR"]; // ip
    $url = "https://www.google.com/recaptcha/api/siteverify"; // verify url
    $captcharesponse = $_POST["g-recaptcha-response"]; // captcha response

    // reCAPTCHA remote validation
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, array(
        'secret' => $secret,
        'response' => $captcharesponse,
        'remoteip' => $remoteip
    ));
    $curlData = curl_exec($curl);
    curl_close($curl);

    // response
    $recaptcha = json_decode($curlData, true);
    
    if ($recaptcha["success"]){
        // reCAPTCHA ok
    } else {
        // reCAPTCHA failed
        died('Lomakkeessa ilmeni virheit, yrit uudelleen.');
    }
    ///
	 
    // Vaaditut kentt
    if(!isset($_POST['name']) ||
        !isset($_POST['email']) ||
        //!isset($_POST['telephone']) ||
        !isset($_POST['comments'])) {
        died('Vaadittuja kentti ei ole tytetty.');      
    }
    
    // Luodaan muuttujat
	$name = $_POST['name'];
	$email_from = $_POST['email'];
	$telephone = $_POST['telephone'];
	$comments = $_POST['comments'];

    // Tarkistetaan ensin pahojen merkkien varalta.
	$combined = $name . $email . $comments;
	if(strpbrk($combined, '<>;')){
        died("Viesti sislt kiellettyj erikoismerkkej (mm. >, < ja ;)");
	};

    // Loput merkit muutetaan vaarattomaksi
	$name  = htmlspecialchars($name, ENT_QUOTES);
	if (!filter_var($email_from, FILTER_VALIDATE_EMAIL)){died('Tarkista shkpostiosoite.');}
	$telephone = htmlspecialchars($telephone, ENT_QUOTES);
	$comments = htmlspecialchars($comments, ENT_QUOTES);

    // Onko kentt sen pituisia mit sovittiin
    if(strlen($name) > 50 || strlen($comments > 800)) {
        died("Nimi tai viesti liian pitk.");
    }

    // Onko viestikentt tyhj
	if(strlen($comments) < 2) {
        died('Viesti ei ole kelvollinen.');
	}

    // Kasataan shkposti
    $email_message = "Lomaketiedot alla.\n\n";
     
    function clean_string($string) {
        $bad = array("content-type","bcc:","to:","cc:","href");
        return str_replace($bad,"",$string);
    }
     
    $email_message .= "Nimi: ".clean_string($name)."\n";
    $email_message .= "Shkposti: ".clean_string($email_from)."\n";
    $email_message .= "Puhelin: ".clean_string($telephone)."\n";
    $email_message .= "Viesti: ".clean_string($comments).$captcharesponse."\n";
     
     
    // Pistetn viesti matkaan
    $headers = 'From: '.$email_from."\r\n".
    'Reply-To: '.$email_from."\r\n" .
    'X-Mailer: PHP/' . phpversion() ."\r\n" .
    'Content-Type: text/plain; charset=UTF-8';
    @mail($email_to, $email_subject, $email_message, $headers); 

    // Palataan sivulle ja ilmoitetaan viesti onnistuneeksi
    $page_url .= "?viesti=sent";
    header( "Location: $page_url" );
}
?>
